import yargs from 'yargs';
export function setup() {
    var startYear = 2020;
    var currentYear = new Date().getFullYear();
    var copyrightYearText = startYear !== currentYear ? startYear + "-" + currentYear : "" + currentYear;
    return (yargs
        .usage('Usage: glugen [flags] [options] [arguments]')
        .option('input', {
        alias: 'i',
        describe: 'Input specification file',
        nargs: 1,
        type: 'string',
        demand: true,
    })
        .option('output', {
        alias: 'o',
        describe: 'Output directory',
        nargs: 1,
        type: 'string',
        demand: true,
    })
        .example('glugen -i openapi.yaml -o ./my-client', 'Generate client into my-client directory from specification in openapi.yaml')
        .help()
        .alias('help', 'h')
        .alias('help', '?')
        .version()
        .alias('version', 'v')
        .epilog("\u00A9 " + copyrightYearText + " rtfpessoa\n      For more information, check out https://glugen.rtfpessoa.xyz/\n      For support, check out https://github.com/rtfpessoa/glugen")
        .strict(true)
        .showHelpOnFail(true)
        .recommendCommands().argv);
}
export function help() {
    yargs.showHelp('log');
}
//# sourceMappingURL=yargs.js.map