var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { toTSType, } from './types';
function getRefName($ref) {
    var _a = $ref.split('/'), componentType = _a[2], name = _a[3];
    var nameSuffix = componentType === 'requestBodies'
        ? 'Body'
        : componentType === 'parameters'
            ? 'Parameter'
            : componentType === 'responses'
                ? 'Response'
                : '';
    return "" + name + nameSuffix;
}
function isReferenceObject(obj) {
    return obj.$ref !== undefined;
}
function renderObject(object) {
    var _a;
    if (isReferenceObject(object)) {
        return getRefName(object.$ref);
    }
    else {
        var nullablePart = ((_a = object.nullable) !== null && _a !== void 0 ? _a : false) ? ' | null' : '';
        if (object.enum !== undefined) {
            return "" + object.enum.map(function (value) { return "'" + value + "'"; }).join(' | ') + nullablePart;
        }
        else if (object.type == 'array') {
            return (object.uniqueItems ? 'Set' : 'Array') + "<" + renderObject(object.items) + ">" + nullablePart;
        }
        else if (object.type == 'object') {
            if (object.properties !== undefined) {
                return ('{ ' +
                    Object.entries(object.properties)
                        .map(function (_a) {
                        var propertyKey = _a[0], propertyValue = _a[1];
                        var _b;
                        var required = (_b = object.required) !== null && _b !== void 0 ? _b : [];
                        return "" + propertyKey + (required.includes(propertyKey) ? '' : '?') + ": " + renderObject(propertyValue) + ";";
                    })
                        .join(' ') +
                    ' }');
            }
            else if (object.anyOf !== undefined) {
                return object.anyOf.map(function (object) { return renderObject(object); }).join(' | ');
            }
            else if (object.allOf !== undefined) {
                return object.allOf.map(function (object) { return renderObject(object); }).join(' & ');
            }
            else {
                throw new Error('Could not render object without properties, anyOf or allOf');
            }
        }
        return "" + toTSType[object.type] + nullablePart;
    }
}
function renderSchema(schemas) {
    if (schemas === void 0) { schemas = {}; }
    return Object.keys(schemas)
        .map(function (key) {
        var object = schemas[key];
        return "export type " + key + " = " + renderObject(object) + ";";
    })
        .join('\n');
}
function renderParameterType(parameter) {
    if (isReferenceObject(parameter)) {
        return getRefName(parameter.$ref);
    }
    else {
        return renderObject(parameter.schema);
    }
}
function renderParameters(parameters) {
    if (parameters === void 0) { parameters = {}; }
    return Object.keys(parameters)
        .map(function (key) {
        return "export type " + key + "Parameter = " + renderParameterType(parameters[key]) + ";";
    })
        .join('\n');
}
function renderRequestBodyType(requestBody) {
    var _a;
    if (isReferenceObject(requestBody)) {
        return getRefName(requestBody.$ref);
    }
    else {
        var required = (_a = requestBody.required) !== null && _a !== void 0 ? _a : false;
        var requiredSuffix = required ? '' : ' | null';
        return "" + renderObject(requestBody.content['application/json'].schema) + requiredSuffix;
    }
}
function renderRequestBodies(requestBodies) {
    if (requestBodies === void 0) { requestBodies = {}; }
    return Object.keys(requestBodies)
        .map(function (key) {
        return "export type " + key + "RequestBody = " + renderRequestBodyType(requestBodies[key]) + ";";
    })
        .join('\n');
}
function renderResponsesType(response) {
    var _a, _b;
    if (isReferenceObject(response)) {
        return getRefName(response.$ref);
    }
    else if (((_b = (_a = response.content) === null || _a === void 0 ? void 0 : _a['application/json']) === null || _b === void 0 ? void 0 : _b.schema) !== undefined) {
        return renderObject(response.content['application/json'].schema);
    }
    else {
        return 'null';
    }
}
function renderResponses(responses) {
    if (responses === void 0) { responses = {}; }
    return Object.keys(responses)
        .map(function (key) {
        return "export type " + key + "Response = " + renderResponsesType(responses[key]) + ";";
    })
        .join('\n');
}
function resolveParameter(param, components) {
    var _a;
    var _b = param.$ref.split('/'), componentType = _b[2], objectName = _b[3];
    if (componentType !== 'parameters') {
        throw new Error("Tried to resolve $ref " + param.$ref + " as parameter but it is of type " + componentType);
    }
    var resolvedParameter = (_a = components.parameters) === null || _a === void 0 ? void 0 : _a[objectName];
    if (resolvedParameter === undefined) {
        throw new Error("Failed to resolve parameter " + objectName);
    }
    return resolvedParameter;
}
function resolveResponse(response, components) {
    var _a;
    var _b = response.$ref.split('/'), componentType = _b[2], objectName = _b[3];
    if (componentType !== 'responses') {
        throw new Error("Tried to resolve $ref " + response.$ref + " as response but it is of type " + componentType);
    }
    var resolvedResponse = (_a = components.responses) === null || _a === void 0 ? void 0 : _a[objectName];
    if (resolvedResponse === undefined) {
        throw new Error("Failed to resolve response " + objectName);
    }
    return resolvedResponse;
}
function resolveSchema(schema, components) {
    var _a;
    var _b = schema.$ref.split('/'), componentType = _b[2], objectName = _b[3];
    if (componentType !== 'schemas') {
        throw new Error("Tried to resolve $ref " + schema.$ref + " as schema but it is of type " + componentType);
    }
    var resolvedSchema = (_a = components.schemas) === null || _a === void 0 ? void 0 : _a[objectName];
    if (resolvedSchema === undefined) {
        throw new Error("Failed to resolve schema " + objectName);
    }
    return resolvedSchema;
}
function renderArgumentParameters(params) {
    if (params.length === 0)
        return;
    return ('{ ' +
        params
            .map(function (param) {
            var _a;
            var required = ((_a = param.required) !== null && _a !== void 0 ? _a : false) ? '' : '?';
            return "" + param.name + required + ": " + param.renderedType + ";";
        })
            .join(' ') +
        ' }');
}
import toJsonSchema from '@openapi-contrib/openapi-schema-to-json-schema';
function renderOperation(pattern, operationName, parameters, operation, components) {
    var operationParameters = operation.parameters || [];
    var allParameters = parameters.concat(operationParameters);
    var _a = allParameters.reduce(function (accumulator, param) {
        var _a;
        var resolvedParam = isReferenceObject(param) ? resolveParameter(param, components) : param;
        accumulator[resolvedParam.in].push({
            name: resolvedParam.name,
            required: (_a = resolvedParam.required) !== null && _a !== void 0 ? _a : false,
            renderedType: renderParameterType(param),
        });
        return accumulator;
    }, {
        path: new Array(),
        header: new Array(),
        query: new Array(),
    }), path = _a.path, header = _a.header, query = _a.query;
    var responseSchemas = Object.entries(operation.responses || {}).reduce(function (responses, _a) {
        var _b;
        var responseKey = _a[0], response = _a[1];
        var _c, _d;
        var dereferencedResponse = isReferenceObject(response) ? resolveResponse(response, components) : response;
        var responseSchema = (_d = (_c = dereferencedResponse.content) === null || _c === void 0 ? void 0 : _c['application/json']) === null || _d === void 0 ? void 0 : _d.schema;
        var resolvedSchema = responseSchema !== undefined
            ? isReferenceObject(responseSchema)
                ? resolveSchema(responseSchema, components)
                : responseSchema
            : undefined;
        var jsonSchema = resolvedSchema !== undefined ? toJsonSchema(resolvedSchema) : undefined;
        return __assign(__assign({}, responses), (_b = {}, _b[responseKey] = jsonSchema, _b));
    }, {});
    var responses = Object.entries(operation.responses || {}).reduce(function (responses, _a) {
        var _b;
        var responseKey = _a[0], response = _a[1];
        return __assign(__assign({}, responses), (_b = {}, _b[responseKey] = renderResponsesType(response), _b));
    }, {});
    var returnTypes = Array.from(new Set(Object.values(responses)).values()).join(' | ');
    var pathParamType = renderArgumentParameters(path);
    var headerParamType = renderArgumentParameters(header);
    var queryParamType = renderArgumentParameters(query);
    var bodyType = operation.requestBody !== undefined ? renderRequestBodyType(operation.requestBody) : undefined;
    return "export function " + operation.operationId + "(\n      " + (pathParamType !== undefined ? "pathParams: " + pathParamType + "," : '') + "\n      " + (headerParamType !== undefined ? "headerParams: " + headerParamType + "," : '') + "\n      " + (queryParamType !== undefined ? "queryParams: " + queryParamType + "," : '') + "\n      " + (bodyType !== undefined ? "body: " + bodyType + "," : '') + "\n    ): Promise<" + returnTypes + "> {\n      return performRequest(\n        '" + operationName.toUpperCase() + "',\n        '" + pattern + "',\n        " + (pathParamType !== undefined ? "pathParams," : '{},') + "\n        " + (headerParamType !== undefined ? "headerParams," : '{},') + "\n        " + (queryParamType !== undefined ? "queryParams," : '{},') + "\n        " + (bodyType !== undefined ? "body," : 'undefined,') + "\n      ).then(([responseCode, responseJson]) => {\n        const responseSchemas: { [statusCode: string]: Schema } = " + JSON.stringify(responseSchemas) + ";\n        const validationOptions = { allowUnknownAttributes: true, preValidateProperty: removeNulls };\n        const responseSchema: Schema | undefined = responseSchemas[responseCode.toString()];\n        const validationResponse =\n          responseSchema !== undefined\n            ? validator.validate(responseJson, responseSchema, validationOptions)\n            : { valid: false, errors: { message: `Response status ${responseCode} does not have a schema defined.` } };\n        if(validationResponse.valid) {\n          return responseJson as Promise<" + returnTypes + "> \n        }\n\n        console.log(JSON.stringify(validationResponse, null, 2));\n        throw new Error(\"Failed to validate schema of response\");\n      });\n  }";
}
function renderPath(pattern, path, components) {
    var commonParameters = path.parameters || [];
    var operations = [];
    if (path.get !== undefined)
        operations.push(['GET', path.get]);
    if (path.put !== undefined)
        operations.push(['PUT', path.put]);
    if (path.post !== undefined)
        operations.push(['POST', path.post]);
    if (path.patch !== undefined)
        operations.push(['PATCH', path.patch]);
    if (path.delete !== undefined)
        operations.push(['DELETE', path.delete]);
    return operations
        .map(function (_a) {
        var operationName = _a[0], operation = _a[1];
        return renderOperation(pattern, operationName, commonParameters, operation, components);
    })
        .join('\n');
}
function renderPaths(paths, components) {
    return Object.entries(paths)
        .map(function (_a) {
        var pattern = _a[0], pathObject = _a[1];
        return renderPath(pattern, pathObject, components);
    })
        .join('\n');
}
function renderUtilFunctions(baseUrl) {
    return "\n  import { URL } from 'url';\n  import fetch from 'node-fetch';\n  import { Schema, Validator } from 'jsonschema';\n\n  const baseUrl = '" + baseUrl + "';\n  const validator = new Validator();\n\n  function removeNulls(instance: { [key: string]: unknown }, property: string): void {\n    const value = instance[property];\n    if (value === null || typeof value == 'undefined') {\n      delete instance[property];\n    }\n  }\n\n  type Parameter = number | boolean | string | undefined\n\n  function performRequest(\n    method: string,\n    path: string,\n    pathParams: { [key: string]: Parameter } = {},\n    headerParams: { [key: string]: Parameter } = {},\n    queryParams: { [key: string]: Parameter } = {},\n    body?: unknown,\n  ): Promise<[number, unknown]> {\n    const requestUrl = new URL(baseUrl);\n  \n    const replacedPath = Object.entries(pathParams).reduce((url, [paramKey, paramValue]) => {\n      return paramValue !== undefined ? url.replace(`{${paramKey}}`, paramValue.toString()) : url;\n    }, path);\n  \n    requestUrl.pathname = requestUrl.pathname + replacedPath;\n  \n    Object.entries(queryParams).forEach(([queryParamKey, queryParamValue]) => {\n      if (queryParamValue !== undefined) requestUrl.searchParams.append(queryParamKey, queryParamValue.toString());\n    });\n  \n    const headers = Object.entries(headerParams).reduce((headers, [headerName, headerValue]) => {\n      if (headerValue !== undefined) headers.push([headerName, headerValue.toString()]);\n      return headers;\n    }, new Array<[string, string]>());\n  \n    const bodyParam = body ? { body: JSON.stringify(body) } : {};\n  \n    return fetch(requestUrl.toString(), {\n      method,\n      headers,\n      ...bodyParam,\n    }).then(async response => {\n      if (response.ok) {\n        const responseTuple: [number, unknown] = [response.status, await response.json()];\n        return responseTuple;\n      }\n  \n      const errorBody = await response.body.read().toString('utf-8');\n      throw new Error(`Request did not succeed got ${response.status} and ${errorBody}`);\n    });\n  }";
}
import Parser from 'swagger-parser';
import fs from 'fs';
function isOpenAPIV3Document(obj) {
    return obj.openapi !== undefined;
}
export function render(input, output) {
    var _a, _b, _c, _d, _e, _f;
    return __awaiter(this, void 0, void 0, function () {
        var document, documentDereferenced, baseUrl, content;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0: return [4, Parser.parse(input)];
                case 1:
                    document = _g.sent();
                    return [4, Parser.dereference(input)];
                case 2:
                    documentDereferenced = _g.sent();
                    if (!isOpenAPIV3Document(document) || !isOpenAPIV3Document(documentDereferenced)) {
                        throw new Error('You must provide a valid OpenAPI v3 document. Swagger v2 is not supported.');
                    }
                    baseUrl = (_b = (_a = document.servers) === null || _a === void 0 ? void 0 : _a[0].url) !== null && _b !== void 0 ? _b : 'http://localhost:9000';
                    content = [
                        renderSchema((_c = document.components) === null || _c === void 0 ? void 0 : _c.schemas),
                        renderRequestBodies((_d = document.components) === null || _d === void 0 ? void 0 : _d.requestBodies),
                        renderParameters((_e = document.components) === null || _e === void 0 ? void 0 : _e.parameters),
                        renderResponses((_f = document.components) === null || _f === void 0 ? void 0 : _f.responses),
                        renderUtilFunctions(baseUrl),
                        renderPaths(document.paths, documentDereferenced.components),
                    ].join('\n\n');
                    if (fs.existsSync(output) && fs.lstatSync(output).isDirectory()) {
                        fs.mkdirSync(output, { recursive: true });
                        fs.writeFileSync(output + "/api-generated.ts", content);
                    }
                    else {
                        fs.writeFileSync(output, content);
                    }
                    return [2];
            }
        });
    });
}
//# sourceMappingURL=render.js.map